
#include	"YC688.h"
#include	"timer.h"
#include  "crc16.h"

//dataw +飬 len = +
void Send_CMD_W(u8 *dataw, u16 len)
{
  u16 i;
  u16 CRC;
  u8  CMD_CRC[128];
  CMD_CRC[0] = 0X5A;
  CMD_CRC[1] = len;
  for(i=2; i<len+2; i++)
    CMD_CRC[i] = dataw[i-2];
  CRC = compute_crc_16(CMD_CRC,len+2);
  CMD_CRC[i] = CRC>>8 & 0xff;
  CMD_CRC[i+1] = CRC & 0xff;
  CMD_CRC[i+2] = 0XA5; 
  for(i=0; i<len+5; i++)
     SEND_USART_DATA(CMD_CRC[i]);
}

//ָļ
//Indexļ 0~65535
void SEND_CMD_SPECIFY_NUM_PLAY(u16 Index)
{
  u8 dataw[3];
  dataw[0] = CMD_SPECIFY_NUM_PLAY;
  dataw[1] = Index>>8&0xff;
  dataw[2] = Index&0xff;
  Send_CMD_W(dataw, 3);
}

//ͣ
void SEND_CMD_STOP(void)
{
  u8 dataw[1];
  dataw[0] = CMD_STOP;
  Send_CMD_W(dataw, 1);
}

//.....................͸ʽдܺ 
void YC688_Test()
{
  SEND_CMD_STOP();
  SEND_CMD_SPECIFY_NUM_PLAY(1);   
}



