
#ifndef	__JY100_H
#define	__JY100_H

#include	"config.h"
#include  "USART.h"

//
enum ME_uart_cmd_define
{
    CMD_PLAY_PAUSE = 0x01,                //0x01  /ͣ                                                                                                               
    CMD_STOP,                             //0x02  ֹͣ                                                                                            
    //CMD_CONTINUE_PLAY,                  //0x03  ָ                                                                                        
    CMD_SET_FF_TIME = 0x04,               //0x04   :ʱ                                                                                  
    CMD_SET_FR_TIME,                      //0x05   :ʱ                                                                                  
    CMD_PREV_TRACK = 0x08,                //0x08  һ   :ǰļ                                                                                                                                                                              
    CMD_NEXT_TRACK,                       //0x09  һ   :ǰļ                                                                      
    CMD_PREV_FLODER,                      //0x0A  һĿ¼ :ǰļ                                                                      
    CMD_NEXT_FLODER,                      //0x0B  һĿ¼ :ǰļ                                                                      
    CMD_SPECIFY_NUM_PLAY,                 //0x0C  ָĿ :ļ                                                                      
    CMD_SPECIFY_PATH_PLAY,                //0x0D  ָ·                                                                                        
    CMD_SPF_FOLDER_TRACK_NUM,             //0x0E  ָĿ¼ĿļŲ                                                                  
    CMD_SWITCH_PLAY_DEVICE,               //0x0F  л豸 :DN豸ţUSB 0, 1SD1, 2SD2, Flash3                                     
    CMD_SET_PLAY_MODE,                    //0x10  òģʽ :PM, 0ȫѭ, 1ѭ, 2ļѭ, 3, 4ֹͣ, 5˳򲥷          
    CMD_SET_EQ,                           //0x11  EQ  :EQ, 0 NORMAL,	1 POP,	2 ROCK,	3 JAZZ,	4 CLASSIC                                     
    CMD_NEXT_EQ,                          //0x12  һEQ                           
    CMD_MUTE_UNMUTE,                      //0x13  /Ǿ                                                                                                                                
    CMD_SET_VOLUME,                       //0x14   :  0~31, Ĭ15                                                                
    CMD_ADD_VOLUME,                       //0x15     : ǰ                                                                         
    CMD_SUB_VOLUME,                       //0x16     : ǰ                                                                         
    
    //ѯ                                                                                                 
    CMD_QUE_PLAY_STATUS = 0x30,           //0x30  ѯ״̬ ز:PS 0ֹͣ, 1, 2ͣ                                                                        
    CMD_QUE_PLAY_MODE,                    //0x31  ѯģʽ ز:PM                                                                                                                                        
    CMD_QUE_VOLUME,                       //0x32  ѯ     ز:                                                                      
    CMD_QUE_ACTIVE_DEVICE,                //0x33  ѯǰ豸 ز:DN                                                                    
    CMD_QUE_DEVICE_ONLINE,                //0x34  ѯǰ豸 ز:DSM                                                                   
    //CMD_QUE_CUR_TRACK,                  //0x35  ѯǰĿ                                                                                    
    CMD_QUE_TOTAL_ON_DEVICE = 0x36,       //0x36  ѯָ洢豸Ŀ ز:                                                                
    CMD_QUE_CUR_FOLDER_FIRST,             //0x37  ѯǰļĿ                                                                    
    CMD_QUE_CUR_FOLDER_TOTAL,             //0x38  ѯǰļĿ                                                                      
    CMD_QUE_SPF_NUM_FIRST,                //0x39  ѯָļĿ                                                                  
    CMD_QUE_SPF_NUM_TOTAL,                //0x3A  ѯָļĿ                                                                    
    CMD_QUERY_EQ,                         //0x3B  ѯEQ                                                                                          
 
    //ݸ                                                                                 
    CMD_CP_SD_FLASH = 0x50,               //0x50  SDݵSPI-FLASH                                          
    CMD_CP_USB_FLASH,                     //0x51  USBݵSPI-FLASH                                                                                                           
   
    //岥                                                                                                            
    CMD_INTER_CUT_SPF_NUM = 0x60,         //0x60  ָĿ岥 :TNH TNL, ز:PS                                                                             
    CMD_INTER_CUT_SPF_FOLDER,             //0x61  ָļбŲ岥 :FNH FNL  ز:PS                                                                                                           
    CMD_STOP_INTER_CUT,                   //0x62  ָļбŲ岥 :FNH FNL  ز:PS                                                    
    
    //ϲ                                                                                       
    CMD_SET_COMBINE_FILE = 0x70,          //0x70  ϲļ                                                           
    CMD_SET_COMBINE_FINISH,               //0x71  ϲļ                                                                                                              
    CMD_STOP_COMBINE_PLAY,                //0x72  ϲ                                                                                    
    
    //                                                                                                            
    //CMD_READ_CONF_FILE = 0x81,          //0x81  ȡCONF.TXT ļ                                                                                              
    CMD_SET_BUSY_OUT_LEVEL = 0x82,        //0x82  BUSYƽ                                                                                                                               
    CMD_SET_PLAY_END_FEEDBACK,            //0x83  òŽǷŽ                                                                                                             
    CMD_RESET_CHIP,                       //0x84  豸λ                                                                                        
    CMD_READ_CODE_VERSION = 0x8F,         //0x8F  ȡ汾                                                                                      
                                                                                                 
    CMD_FEEDBACK_PALY_END = 0xA0,         //0xA0  Ž                                                            
    CMD_FEEDBACK_DEVICE_CHANGE,           //0xA1  豸ź                                                        
    CMD_INIT_FINISH                       //0xA2  оƬʼ   
};



#define SEND_USART_DATA(x)   TX1_write2buff(x)     //byteͺ 
void YC688_Test();                    //
void Send_CMD_W(u8 *dataw, u16 len);  //CMD
#endif