
#include	"timer.h"

TIM_COUNT TIM_Dalay;//ʱ

//ʱ
u8 TIM_100us[T100US_NUM];   //100us
u8 TIM_1ms[T1MS_NUM];       //1ms
u8 TIM_10ms[T10MS_NUM];     //10ms
u8 TIM_100ms[T100MS_NUM];   //100ms
u8 TIM_1000ms[T1000MS_NUM]; //1000ms

TIM_COUNT TIM_Timer1 = {0, 1,     1     };   //ʱ1     100us
TIM_COUNT TIM_Timer2 = {0, 10,    10    };   //ʱ2     1ms
TIM_COUNT TIM_Timer3 = {0, 100,   100   };   //ʱ3     10ms
TIM_COUNT TIM_Timer4 = {0, 1000,  1000  };   //ʱ4     100ms
TIM_COUNT TIM_Timer5 = {0, 10000, 10000 };   //ʱ5     1000ms

/************************ ʱ ****************************/
void	Timer_config(void)
{  
	TIM_InitTypeDef		TIM_InitStructure;					//ṹ
	TIM_InitStructure.TIM_Mode      = TIM_16BitAutoReload;	//ָģʽ,   TIM_16BitAutoReload,TIM_16Bit,TIM_8BitAutoReload,TIM_16BitAutoReloadNoMask
	TIM_InitStructure.TIM_Polity    = PolityLow;			//ָжȼ, PolityHigh,PolityLow
	TIM_InitStructure.TIM_Interrupt = ENABLE;				//жǷ,   ENABLEDISABLE
	TIM_InitStructure.TIM_ClkSource = TIM_CLOCK_1T;			//ָʱԴ,     TIM_CLOCK_1T,TIM_CLOCK_12T,TIM_CLOCK_Ext
	TIM_InitStructure.TIM_ClkOut    = DISABLE;				//Ƿ, ENABLEDISABLE
	TIM_InitStructure.TIM_Value     = 65536UL - (MAIN_Fosc / 10000UL);		//ֵ,ʱж100usһ
	TIM_InitStructure.TIM_Run       = ENABLE;				//Ƿʼʱ, ENABLEDISABLE
	Timer_Inilize(Timer0,&TIM_InitStructure);				//ʼTimer0	  Timer0,Timer1,Timer2
	
//	Timer_Inilize(Timer1,&TIM_InitStructure);				//ʼTimer0	  Timer0,Timer1,Timer2
//	Timer_Inilize(Timer2,&TIM_InitStructure);				//ʼTimer0	  Timer0,Timer1,Timer2
  EA = 1;
  Delay1Ms(1);
  Delay100us(1);
}


/********************* Timer0жϺ************************/
void timer0_int (void) interrupt TIMER0_VECTOR
{
//	 timer0Mark = 1;
	
	if(TIM_Dalay.Mark)		  //ʱ100us
	{
		if(TIM_Dalay.Count-- == 0)
		{
			 TIM_Dalay.Mark  = 0;
		}
	}
  if(!TIM_Timer1.Mark) if(TIM_Timer1.Count-- == 0) TIM_Timer1.Mark = 1, TIM_Timer1.Count = TIM_Timer1.Initial;    //100us
  if(!TIM_Timer2.Mark) if(TIM_Timer2.Count-- == 0) TIM_Timer2.Mark = 1, TIM_Timer2.Count = TIM_Timer2.Initial;    //1ms
  if(!TIM_Timer3.Mark) if(TIM_Timer3.Count-- == 0) TIM_Timer3.Mark = 1, TIM_Timer3.Count = TIM_Timer3.Initial;    //10ms
  if(!TIM_Timer4.Mark) if(TIM_Timer4.Count-- == 0) TIM_Timer4.Mark = 1, TIM_Timer4.Count = TIM_Timer4.Initial;    //100ms
  if(!TIM_Timer5.Mark) if(TIM_Timer5.Count-- == 0) TIM_Timer5.Mark = 1, TIM_Timer5.Count = TIM_Timer5.Initial;    //1000ms
  GetTimer();
}

/********************* Timer1жϺ************************/
void timer1_int (void) interrupt TIMER1_VECTOR
{
   //P26 = ~P26;

}

/********************* Timer2жϺ************************/
void timer2_int (void) interrupt TIMER2_VECTOR
{
	//P10 = ~P10;
}

void Delay100us(unsigned int _US)	 	 //ʱ100us
{
	TIM_Dalay.Count = _US;
	TIM_Dalay.Mark  = 1;
	while (TIM_Dalay.Mark);
}
void Delay1Ms(unsigned int _MS)	 	 //ʱ1ms
{
	TIM_Dalay.Count = _MS * 10;
	TIM_Dalay.Mark  = 1;
	while (TIM_Dalay.Mark);
}



//========================================================================
// : u8	Timer_Inilize(u8 TIM, TIM_InitTypeDef *TIMx)
// : ʱʼ.
// : TIMx: ṹ,οtimer.hĶ.
// : ɹ0, ղ1,󷵻2.
// 汾: V1.0, 2012-10-22
//========================================================================
u8	Timer_Inilize(u8 TIM, TIM_InitTypeDef *TIMx)
{  
	if(TIM > Timer2)	return 1;	//ղ

	if(TIM == Timer0)
	{
		TR0 = 0;		//ֹͣ
		if(TIMx->TIM_Interrupt == ENABLE)		ET0 = 1;	//ж
		else									ET0 = 0;	//ֹж
		if(TIMx->TIM_Polity == PolityHigh)		PT0 = 1;	//ȼж
		else									PT0 = 0;	//ȼж
		if(TIMx->TIM_Mode >  TIM_16BitAutoReloadNoMask)	return 2;	//
		TMOD = (TMOD & ~0x03) | TIMx->TIM_Mode;	//ģʽ,0: 16λԶװ, 1: 16λʱ/, 2: 8λԶװ, 3: 16λԶװ, ж
		if(TIMx->TIM_ClkSource == TIM_CLOCK_12T)	AUXR &= ~0x80;	//12T
		if(TIMx->TIM_ClkSource == TIM_CLOCK_1T)		AUXR |=  0x80;	//1T
		if(TIMx->TIM_ClkSource == TIM_CLOCK_Ext)	TMOD |=  0x04;	//Ƶ
		else										TMOD &= ~0x04;	//ʱ
		if(TIMx->TIM_ClkOut == ENABLE)	INT_CLKO |=  0x01;	//ʱ
		else							INT_CLKO &= ~0x01;	//ʱ
		
		TH0 = (u8)(TIMx->TIM_Value >> 8);
		TL0 = (u8)TIMx->TIM_Value;
		if(TIMx->TIM_Run == ENABLE)	TR0 = 1;	//ʼ
		return	0;		//ɹ
	}

	if(TIM == Timer1)
	{
		TR1 = 0;		//ֹͣ
		if(TIMx->TIM_Interrupt == ENABLE)		ET1 = 1;	//ж
		else									ET1 = 0;	//ֹж
		if(TIMx->TIM_Polity == PolityHigh)		PT1 = 1;	//ȼж
		else									PT1 = 0;	//ȼж
		if(TIMx->TIM_Mode >= TIM_16BitAutoReloadNoMask)	return 2;	//
		TMOD = (TMOD & ~0x30) | TIMx->TIM_Mode;	//ģʽ,0: 16λԶװ, 1: 16λʱ/, 2: 8λԶװ
		if(TIMx->TIM_ClkSource == TIM_CLOCK_12T)	AUXR &= ~0x40;	//12T
		if(TIMx->TIM_ClkSource == TIM_CLOCK_1T)		AUXR |=  0x40;	//1T
		if(TIMx->TIM_ClkSource == TIM_CLOCK_Ext)	TMOD |=  0x40;	//Ƶ
		else										TMOD &= ~0x40;	//ʱ
		if(TIMx->TIM_ClkOut == ENABLE)	INT_CLKO |=  0x02;	//ʱ
		else							INT_CLKO &= ~0x02;	//ʱ
		
		TH1 = (u8)(TIMx->TIM_Value >> 8);
		TL1 = (u8)TIMx->TIM_Value;
		if(TIMx->TIM_Run == ENABLE)	TR1 = 1;	//ʼ
		return	0;		//ɹ
	}

	if(TIM == Timer2)		//Timer2,̶Ϊ16λԶװ, жȼ
	{
		AUXR &= ~(1<<4);	//ֹͣ
		if(TIMx->TIM_Interrupt == ENABLE)			IE2  |=  (1<<2);	//ж
		else										IE2  &= ~(1<<2);	//ֹж
		if(TIMx->TIM_ClkSource >  TIM_CLOCK_Ext)	return 2;
		if(TIMx->TIM_ClkSource == TIM_CLOCK_12T)	AUXR &= ~(1<<2);	//12T
		if(TIMx->TIM_ClkSource == TIM_CLOCK_1T)		AUXR |=  (1<<2);	//1T
		if(TIMx->TIM_ClkSource == TIM_CLOCK_Ext)	AUXR |=  (1<<3);	//Ƶ
		else										AUXR &= ~(1<<3);	//ʱ
		if(TIMx->TIM_ClkOut == ENABLE)	INT_CLKO |=  0x04;	//ʱ
		else							INT_CLKO &= ~0x04;	//ʱ

		TH2 = (u8)(TIMx->TIM_Value >> 8);
		TL2 = (u8)TIMx->TIM_Value;
		if(TIMx->TIM_Run == ENABLE)	AUXR |=  (1<<4);	//ʼ
		return	0;		//ɹ
	}
	return 2;	//
}

//ȡʱ
void GetTimer(void)       //ȡʱ
{ 
  u8 i;
  if(TIM_Timer1.Mark)     //100usλ
  {
    TIM_Timer1.Mark = 0;
    for(i=0; i<5; i++)
      TIM_100us[i] = TRUE; 
  }
  if(TIM_Timer2.Mark)     //1msλ
  {
    TIM_Timer2.Mark = 0;
    for(i=0; i<5; i++)
      TIM_1ms[i] = TRUE; 
  }
  if(TIM_Timer3.Mark)     //10msλ
  {
    TIM_Timer3.Mark = 0;
    for(i=0; i<5; i++)
      TIM_10ms[i] = TRUE; 
  }
  if(TIM_Timer4.Mark)     //100msλ
  {
    TIM_Timer4.Mark = 0;
    for(i=0; i<5; i++)
      TIM_100ms[i] = TRUE; 
  }
  if(TIM_Timer5.Mark)     //1000msλ
  {
    TIM_Timer5.Mark = 0;
    for(i=0; i<5; i++)
      TIM_1000ms[i] = TRUE; 
  }
}
